function [T_s, Shipname_slow] = Draw_T_s(Scheduling_list, Arrival_segment, Traversing_time, Waiting_time)

nShips = size(Scheduling_list,1);

Waiting_time = kron(Waiting_time, [1,0]);

Arrival_segment = [zeros(size(Arrival_segment,1), 1), Arrival_segment, zeros(size(Arrival_segment,1), 1)];

Waiting_time = [zeros(size(Waiting_time,1), 1), Waiting_time, zeros(size(Waiting_time,1), 1)];

Firstslow = NaN(nShips,1);

Ship_nr = NaN(nShips,1);

for i = 1:nShips
    if Scheduling_list{i,9} == 1
        % If the ship is slow on some segment
        SlowSegments = find(cell2mat(Scheduling_list(i,10:end))>0);
        if Scheduling_list{i,4} == 1
            % If eastbound
            Arrival_segment(i, end) = Arrival_segment(i, end-1) +  Traversing_time(i, end-1);
            Firstslow(i) = min(Arrival_segment(i, SlowSegments+2)-Waiting_time(i, SlowSegments+1));
            Ship_nr(i) = i;
        elseif Scheduling_list{i,4} == -1
            % If westbound
            Arrival_segment(i, 1) = Arrival_segment(i, 2) +  Traversing_time(i, 2);
            Firstslow(i) = min(Arrival_segment(i, SlowSegments)-Waiting_time(i, SlowSegments+1));
            Ship_nr(i) = i;
        else
            msgbox('Something went wrong in Draw_T_s', 'Error message')
        end
    end
end

[T_s, ind] = min(Firstslow); 
if isnan(T_s)
    Shipname_slow = NaN;
else
    Shipname_slow = Scheduling_list{ind, 1};
end

end