function [Kiel_length_new, Arrival_segment_ship] = Draw_schedule(Waiting_time, Arrival_segment, Direction, Kiel_length, Traversing_time, Traffic_group_number, Passage_number, ShipNames, time)

% Find all ships that have no yet started their voyage
EmptyRows = find(sum(Arrival_segment,2)==0);
% Remove these ships from the inputs
Arrival_segment(EmptyRows,:) = [];
Traversing_time(EmptyRows,:) = [];
Waiting_time(EmptyRows,:) = [];

%Legger til ekstra kolonne i Arrival_segment matrise for  f med alle
%segment boundaries
nShips = size(Waiting_time,1);
expand = zeros(nShips,1);
Arrival_segment = horzcat(Arrival_segment,expand);

%Legger til utgangstiden fra kanalen (siste arrival-tid +
%traverseringstid + eventuell venting), avhenger av retning
for i = 1:nShips
   if Direction(i) == 1 % Dersom eastbound
       a = Arrival_segment(i,:);
       b = Arrival_segment(i,length(a)-1);
       a = [a(1:length(a)-1), b + Traversing_time(i,length(Traversing_time(i,:))) + Waiting_time(i,length(Waiting_time(i,:)))];
       Arrival_segment(i,:) = a;
    elseif Direction (i) == -1
       a = Arrival_segment(i,:);
       b = Arrival_segment(i,1);
       a = [0, a(1:length(a)-1)];
       a = [b + Traversing_time(i,1) + Waiting_time(i,1) , a(2:length(a))];
       Arrival_segment(i,:) = a;
    end
    
end
    
    
Arrival_segment = -Arrival_segment;

%Creating cell array
% Trenge me det siste 1-tallet?
Arrival_segment_ship = cell(nShips,1,1);
Kiel_length_new = cell(nShips,1,1);

for i = 1:nShips
     Kiel_length_new {i} = Kiel_length;
     Arrival_segment_ship{i} = Arrival_segment(i,:);
end

%Initialiserer vektor med index til skip som er historisk case. Skiller p
%historisk og internal entering case p dette vis:
% M skille mellom historisk case og internal entering. Historisk case vil
% alltid ha 0 etter strste tall (Direction = 1), og 0 fr strste tall
% (Direction = -1). Internal entering vil alltid ha 0 fr minste tall
% (Direction = 1), og 0 etter minste tall (Direction = -1).

HistoricShips = [];

for i = 1:nShips
    if Direction(i) == 1
        %Hvis eastbound, s finn den seneste tiden. Hvis denne tiden ikke hrer
        %til siste segment s er skipet historisk (det er nullere etter strste tall i abs.verdi).
        if max(find(Arrival_segment(i,:))) ~= length(Arrival_segment(i,:))
            HistoricShips = [HistoricShips, i];
        end 
        %Hvis westbound, s finn den tidligste tiden. Hvis denne tiden ikke hrer
        %til frste segment s er skipet historisk (det er nullere fr strste tall i abs.verdi).
    elseif Direction(i) == -1
        if min(find(Arrival_segment(i,:))) ~= 1
            HistoricShips = [HistoricShips, i];
        end
    end
end

for i = 1:nShips
    %Teller gjennom sidings
    for j=1:2:length(Kiel_length)
        %Teller gjennom hver bt sin ventetid i sidings
        if Waiting_time(i,(j+1)/2) ~= 0
            %Hvis venting lages ny Kiel_length vektor som dupliserer siding
            %Hvis venting lages ny arrival_segment vektor som legger til
            %arrival time + venting
            if Direction(i) == 1
                Arrival_segment_ship {i} = sort([Arrival_segment_ship{i}, Arrival_segment(i,j+1) + Waiting_time(i,(j+1)/2)],'descend');
                Kiel_length_new {i} = sort([Kiel_length_new{i}, Kiel_length(j+1)]);
            elseif Direction(i) == -1
                Arrival_segment_ship{i} = sort([Arrival_segment_ship{i}, Arrival_segment(i,j) + Waiting_time(i,(j+1)/2)],'ascend');
                Kiel_length_new{i} = sort([Kiel_length_new{i}, Kiel_length(j)]);
            end
        end
    end
end

for i=1:nShips
    Arrival_segment_ship{i}(find(Arrival_segment_ship{i} > 0)) = 0;
    Indicies = find(Arrival_segment_ship{i} == 0);
    Arrival_segment_ship{i}(Indicies) = [];
    %Historisk, eastbound skip
    if Direction(i) == 1 && ismember(i, HistoricShips)
        Kiel_length_new{i}((end-length(Indicies)+1):end) = [];
    %Internal entering, eastbound skip
    elseif Direction(i) == 1 && ~ismember(i, HistoricShips)
        Kiel_length_new{i}(Indicies) = [];        
    %Historisk, westbound skip
    elseif Direction(i) == -1 && ismember(i, HistoricShips)
        Kiel_length_new{i}(1:length(Indicies)) = [];
    %Internal entering, westbound skip
    elseif Direction(i) == -1 && ~ismember(i, HistoricShips)
        Kiel_length_new{i}(Indicies) = [];
    end
end

hold on
longesttime = zeros(1, nShips);

for i = 1:nShips
    longesttime(i) = min(Arrival_segment_ship{i});
end 
longesttime = min(min(longesttime));
Canallength = max(Kiel_length);

axis([0, Canallength, longesttime, 0])

%Farger sidings gr
X = {};
X_plot={};
Y = [-100000 0 0 -100000];
for i=1:2:length(Kiel_length)
    X{(i+1)/2} = [Kiel_length(i) Kiel_length(i) Kiel_length(i+1) Kiel_length(i+1)];
    X_plot{(i+1)/2} = fill(X{(i+1)/2}, Y, [0.8 0.8 0.8]);
    set(X_plot{(i+1)/2}, 'edgecolor', 'none');
end

%Plotter linjediagram for hver bt
legendInfo = {};
B_plot = zeros(1, nShips);
for i = 1:nShips
    B_plot (i) = plot(Kiel_length_new {i}, Arrival_segment_ship{i});
    %set(B_plot(i), 'LineWidth', 4);
    legendInfo {i} = [ShipNames{i}, ', TGN ' num2str(Traffic_group_number(i))]; 
end 
lgd = legend (B_plot, legendInfo);
lgd.FontSize = 8;

txt1 = ['Time = ', num2str(time)];
ylim=get(gca,'ylim');
xlim=get(gca,'xlim');
text(xlim(1),ylim(2)-30,txt1)

%Lager x-verdier for sidings i plotet
X = zeros(1,size(Waiting_time,2)-1);
for i=1:length(Kiel_length)-1
    if mod(i,2)~= 0
        X((i+1)/2) = Kiel_length(i+1);
    end
end

%Lager punkter hvor passage number skal plasseres
x1 = zeros(1,length(Passage_number));
y1 = ones(1,length(Passage_number))*min(Arrival_segment(:))/2;
%Skriver ut passage number til plot
for i = 1:length(Passage_number)
    x1(i) = Kiel_length(i) + ((Kiel_length(i+1)-Kiel_length(i))/2);
    txt = num2str(Passage_number(i));
    text(x1(i), y1(i), txt);
end
hold off
end 