function online_mos = Fix_variables_vol3(initial_mos, ShipNames, Scheduling_list, Arrival_segment, Traversing_time, Waiting_time, Waiting_outside, Current_segment, time)

nSchedulingList = size(Scheduling_list,1);
nPlannedfor = size(ShipNames,1);

ShipsInScheduling = zeros(nSchedulingList,1);
ShipsInCurrentPlan = zeros(nPlannedfor,1);

for i = 1:nSchedulingList
    ShipsInScheduling(i) = str2num(Scheduling_list{i,1}(8:end));
end

for i = 1:nPlannedfor
    ShipsInCurrentPlan(i) = str2num(ShipNames{i}(8:end));
end

RemovedShip = setdiff(ShipsInCurrentPlan, ShipsInScheduling);
AddedShip = setdiff(ShipsInScheduling, ShipsInCurrentPlan);
index_AddedShip = zeros(length(AddedShip),1);

for i = 1:length(AddedShip)
    index_AddedShip(i) = find(AddedShip(i) == ShipsInScheduling);
end

ShipsForFixating = setdiff(ShipsInCurrentPlan, RemovedShip);
indicies = setdiff(ShipsForFixating, AddedShip);
n = length(indicies);

for i = 1:n
    j = find(ShipsForFixating(i) == ShipsInCurrentPlan);
    k = find(ShipsForFixating(i) == ShipsInScheduling);
    %if ShipsInScheduling(i) == AddedShip
    %    continue;
    %end
    if Arrival_segment(j, Current_segment(j)) < time
        Index = find(contains(initial_mos,'minimize(WaitingTime);'));
        Index = Index - 1;
        initial_mos(Index+3:end+3,:) = initial_mos(Index:end,:);
        initial_mos(Index,:) = {strcat('t(', num2str(k),',',num2str(Current_segment(j)),') >= ',num2str(Arrival_segment(j, Current_segment(j)), 16),';')};
        initial_mos(Index+1,:) = {strcat('t(', num2str(k),',',num2str(Current_segment(j)),') <= ',num2str(Arrival_segment(j, Current_segment(j))+0.01, 16),';')};
        initial_mos(Index+2,:) = {strcat('s(', num2str(k),',',num2str(Current_segment(j)),') =',num2str(Traversing_time(j, Current_segment(j)), 16),';')};
        if (mod(Current_segment(j),2) == 1) && (Waiting_time(j,(Current_segment(j)+1)/2) > 0)
            Index = find(contains(initial_mos,'minimize(WaitingTime);'));
            Index = Index - 1;
            initial_mos(Index+1:end+1,:) = initial_mos(Index:end,:);
            initial_mos(Index,:) = {strcat('w(', num2str(k),',',num2str(Current_segment(j)),') >= ', num2str(time - (Arrival_segment(j, Current_segment(j)) + Traversing_time(j, Current_segment(j)))),';')};
        end
    end
    if Waiting_outside(j) > 0
        if time < Arrival_segment(j,Current_segment(j)) && time > Scheduling_list{k,3}
            Index = find(contains(initial_mos,'minimize(WaitingTime);'));
            Index = Index - 1;
            initial_mos(Index+1:end+1,:) = initial_mos(Index:end,:);
            initial_mos(Index,:) = {strcat('Waitoutside(', num2str(k), ') >= ', num2str((time - Scheduling_list{k,3}), 16),';')};
        end
    end
end

online_mos = initial_mos;
end